Scriptname TP1_Teleport extends activemagiceffect  

TP1_VariableStore Property Store Auto
Explosion Property defaultGhostDeathExplosion Auto
VisualEffect  Property MGTeleportInEffect Auto
VisualEffect  Property MGTeleportOutEffect Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)

    Store.Init()
    
    if(!Game.GetPlayer().IsSneaking())
        OpenAttunementMenu()
    else
        GoBackToMarker()
    endif

EndEvent


Function OpenAttunementMenu()
    uilistmenu menu = uiextensions.GetMenu("UIListMenu") as uilistmenu

    menu.AddEntryItem(Store.GetOptionName(0))

    if(Store.HasMarkers())
        int i = 0
        While (i < Store.GetBiggestIndex())
            menu.AddEntryItem(Store.GetOptionName(i+1))
            i += 1
        EndWhile
    else
        menu.AddEntryItem("[No anchors set]")
    endif
    menu.OpenMenu()
    if(Store.HasMarkers())
        int result = menu.GetResultInt()

        if(result != -1)
            Store.SelectOption(result)
            GoToMarker(result)
        endif
    endif


EndFunction


Function GoToMarker(int index)

    Store.Init()

    Actor player = Game.GetPlayer()

    if(store.GetMarker1() != none)

        Store.PlaceMarker2()

        MGTeleportOutEffect.Play(player, 1.5)
        utility.wait(2.5)
        player.setalpha(0.0, false)
        utility.wait(0.5)

        player.MoveTo(Store.GetMarker1())

        MGTeleportInEffect.Play(player, 1.0)
        utility.wait(0.1)
        player.setalpha(1.0, true)
        utility.wait(0.9)

        Store.SetMarker2AsLastMarker()
    else
        player.PlaceAtMe(defaultGhostDeathExplosion)
    endif

EndFunction

Function GoBackToMarker()

    Store.Init()

    Actor player = Game.GetPlayer()
    
    if(store.GetLastMarker() != none && Store.HasMarkers())

        bool isTeleportingFoward = store.IsMarker1Last()

        if(isTeleportingFoward)
            Store.PlaceMarker2()
        endif

        MGTeleportOutEffect.Play(player, 1.5)
        utility.wait(2.5)
        player.setalpha(0.0, false)
        utility.wait(0.5)

        if(isTeleportingFoward)
            player.MoveTo(Store.GetMarker1())
        else
            player.MoveTo(Store.GetMarker2())
        endif
        
        MGTeleportInEffect.Play(player, 1.0)
        utility.wait(0.1)
        player.setalpha(1.0, true)
        utility.wait(0.9)

        if(isTeleportingFoward)
            Store.SetMarker2AsLastMarker()
        else
            Store.SetMarker1AsLastMarker()
        endif
    else
        player.PlaceAtMe(defaultGhostDeathExplosion)
    endif
EndFunction