Scriptname TP1_TeleportAttunement extends activemagiceffect  

TP1_VariableStore Property Store Auto
VisualEffect Property TP1_PlaceMarkerVFX Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)

    Store.Init()
    OpenAttunementMenu()

EndEvent

Function OpenAttunementMenu()
    uilistmenu menu = uiextensions.GetMenu("UIListMenu") as uilistmenu

    bool CanAddOption = Store.CanAddOption()

    int i = 0
    While (i < Store.GetBiggestIndex())
        menu.AddEntryItem(Store.GetOptionName(i),-1,-1,true)
        int realIndex = (i * 4) 
        menu.AddEntryItem("[Rename]", realIndex)
        menu.AddEntryItem("[Delete]", realIndex)
        menu.AddEntryItem("[Delete "+ Store.GetOptionName(i) + "]", realIndex+2)
        i += 1
    EndWhile

    if(CanAddOption)
        menu.AddEntryItem("[New]")
    else
        menu.AddEntryItem("[Max anchors reached]")
    endif

    menu.OpenMenu()
    int result = menu.GetResultInt()

    if (result == (Store.GetBiggestIndex() * 4))
        if(CanAddOption)
            string pickResult = GetNewOptionName()
            if(pickResult != "")
                Store.AddOption(pickResult)
                Store.PlaceMarker1()
                Store.SetMarker1AsLastMarker()
                TP1_PlaceMarkerVFX.Play(Game.GetPlayer(), 1.0)
            endif
        else
            OpenAttunementMenu()
        endif
    else
        int item = (result / 4)
        int option = result  % 4
        if(option == 1)
            string pickResult = GetOptionNewName(item)
            if(pickResult != "")
                Store.Rename(item, pickResult)
            endif
            OpenAttunementMenu()
        elseif (option == 3)
            Store.DeleteItem(item)
            OpenAttunementMenu()
        endif
    endif
EndFunction

string Function GetNewOptionName()
    uitextentrymenu textMenu = uiextensions.GetMenu("UITextEntryMenu") as uitextentrymenu
    textMenu.SetPropertyString("text","")
    textMenu.OpenMenu()
    return textMenu.GetResultString()
EndFunction

string Function GetOptionNewName(int index)
    uitextentrymenu textMenu = uiextensions.GetMenu("UITextEntryMenu") as uitextentrymenu
    textMenu.SetPropertyString("text", Store.GetRenameOption(index))
    textMenu.OpenMenu()
    return textMenu.GetResultString()
EndFunction