Scriptname TP1_VariableStore extends Quest  

Activator Property TP1_Activator Auto

ObjectReference[] Marker1
ObjectReference Marker2
ObjectReference LastMarker
string[] SlotNames
int BiggestIndex
int SelectedIndex

bool Function HasMarkers()
    return BiggestIndex != 0
EndFunction

Function Init()
    if(Marker1.Length == 0)
        Marker1 = new ObjectReference[30] 
        SlotNames = new string[30] 
        BiggestIndex = 0
        SelectedIndex = 0
    endif
EndFunction

int Function GetBiggestIndex()
    return BiggestIndex
EndFunction

Function SelectOption(int currentIndex)
    SelectedIndex = currentIndex
    LastMarker = Marker1[SelectedIndex]
EndFunction

bool Function CanAddOption()
    if(BiggestIndex > 30)
        return false
    endif
    return true
EndFunction

Function DeleteItem(int index)
    int i = index
    
    While (i < BiggestIndex)
        Marker1[i] = Marker1[i + 1]
        SlotNames[i] = SlotNames[i + 1] 
        i += 1
    EndWhile

    Marker1[BiggestIndex] = none
    LastMarker = none
    SlotNames[BiggestIndex] = none

    if(SelectedIndex == BiggestIndex)
        SelectedIndex = 0
    endif

    BiggestIndex -= 1

EndFunction

Function AddOption(string newName)
    SlotNames[BiggestIndex] = newName
    SelectedIndex = BiggestIndex
    BiggestIndex += 1
EndFunction

Function Select(int index)
    SelectedIndex = index
EndFunction

Function Rename(int index, string newName)
    SlotNames[index] = newName
EndFunction

string Function GetOptionName(int currentIndex)
    return SlotNames[currentIndex]
EndFunction

string Function GetRenameOption(int currentIndex)
    return SlotNames[currentIndex] 
EndFunction

ObjectReference Function GetMarker1()
    return Marker1[SelectedIndex]
EndFunction
ObjectReference Function GetMarker2()
    return Marker2
EndFunction

ObjectReference Function GetLastMarker()
    return LastMarker
EndFunction

bool Function IsMarker1Last()
    return Marker1[SelectedIndex] == LastMarker
EndFunction

Function SetMarker1AsLastMarker()
    LastMarker = Marker1[SelectedIndex]
EndFunction
Function SetMarker2AsLastMarker()
    LastMarker = Marker2
EndFunction

Function PlaceMarker1()
    if(Marker1[SelectedIndex] == none)
        Marker1[SelectedIndex] = Game.GetPlayer().PlaceAtMe(TP1_Activator, 1,true,false)
    else
        Marker1[SelectedIndex].MoveTo(Game.GetPlayer())
    endif
EndFunction

Function DeleteMarker1()
    if(Marker1[SelectedIndex] != none)
        Marker1[SelectedIndex].Delete()
        Marker1[SelectedIndex] = none
    endif
EndFunction

Function PlaceMarker2()
    if(Marker2 == none)
        Marker2 = Game.GetPlayer().PlaceAtMe(TP1_Activator, 1,true,false)
    else
        Marker2.MoveTo(Game.GetPlayer())
    endif
EndFunction
